// CFAX_WINTESTDlg.cpp : implementation file

#include "stdafx.h"
#include "CFAX_WINTEST.h"
#include "CFAX_WINTESTDlg.h"

//Parallel port direct access stuff
#include "dlportio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)

	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCFAX_WINTESTDlg dialog

CCFAX_WINTESTDlg::CCFAX_WINTESTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCFAX_WINTESTDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCFAX_WINTESTDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCFAX_WINTESTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCFAX_WINTESTDlg)
	DDX_Control(pDX, IDC_ADDRESS, m_address);
	DDX_Control(pDX, IDC_DEVICE, m_device);
	DDX_Control(pDX, IDC_Shift_Slider, m_Shift_Slider);
	DDX_Control(pDX, IDC_Shift_Setting, m_Shift_Setting);
	DDX_Control(pDX, IDC_Range_Setting, m_Range_Setting);
	DDX_Control(pDX, IDC_Range_Slider, m_Range_Slider);
	DDX_Control(pDX, IDC_Contrast_Slider, m_Contrast_Slider);
	DDX_Control(pDX, IDC_Contrast_Setting, m_Contrast_Setting);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCFAX_WINTESTDlg, CDialog)
	//{{AFX_MSG_MAP(CCFAX_WINTESTDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_INITIALIZE, OnInitialize)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(ID_CLEAR, OnClear)
	ON_BN_CLICKED(ID_CHECKERBOARD, OnCheckerboard)
	ON_BN_CLICKED(ID_H_Stripes, OnHStripes)
	ON_BN_CLICKED(ID_V_Stripes, OnVStripes)
	ON_BN_CLICKED(ID_SET, OnSet)
	ON_BN_CLICKED(ID_Diagonals, OnDiagonals)
	ON_BN_CLICKED(ID_Tractor, OnTractor)
	ON_BN_CLICKED(ID_Logo, OnLogo)
	ON_CBN_EDITCHANGE(IDC_DEVICE, OnEditchangeDevice)
	ON_CBN_EDITCHANGE(IDC_ADDRESS, OnEditchangeAddress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCFAX_WINTESTDlg message handlers


// Global / Locals / Whatever they are now.
int
  last_contrast;
#define CFAX12864T_CONTRAST (25)
#define CFAX12864U_CONTRAST (9)
int
  last_range;
#define CFAX12864T_RANGE (4)
#define CFAX12864U_RANGE (5)
int
  last_shift;
int
  display_type; //0=CFAX12864T 1=CFAX12864U
int
  port_data_address; //0 => 0x378, 1 => 0x278. 2 => 0x3BC
int
  port_control_address; //port_data_address + 2
/////////////////////////////////////////////////////////////////////////////
const unsigned char CFAX12864T[8][128]={
   {0xF0,0xFC,0x0E,0x07,0x03,0x03,0x03,0x07,
		 0x0E,0x0C,0x00,0xFF,0xFF,0x83,0x83,0x83,
		 0x83,0x83,0xC7,0xFE,0x7C,0x00,0x03,0x0F,
		 0x3C,0xF0,0xC0,0xC0,0xF0,0x3C,0x0F,0x03,
		 0x00,0x3C,0x7E,0xE7,0xC3,0xC3,0xC3,0xC3,
		 0xC7,0x8E,0x0C,0x00,0x03,0x03,0x03,0xFF,
		 0xFF,0x03,0x03,0x03,0x00,0x00,0xE0,0xFC,
		 0x1F,0x1F,0xFC,0xE0,0x00,0x00,0x00,0x00,
		 0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x00,0x00,0xFF,0xFF,0xC3,0xC3,
		 0xC3,0xC3,0xC3,0xC3,0x03,0x03,0xF0,0xFC,
		 0x0E,0x07,0x03,0x03,0x07,0x0E,0xFC,0xF0,
		 0x00,0x00,0xFF,0xFF,0x0E,0x38,0xF0,0xC0,
		 0x00,0x00,0xFF,0xFF,0x00,0x03,0x03,0x03,
		 0xFF,0xFF,0x03,0x03,0x03,0x00,0x03,0x03,
		 0x03,0x03,0xC3,0xE3,0x33,0x1F,0x0F,0x03},
		 {0x03,0x0F,0x1C,0x38,0x30,0x30,0x30,0x38,
		 0x1C,0x0C,0x00,0x3F,0x3F,0x01,0x01,0x03,
		 0x07,0x0F,0x1D,0x38,0x30,0x00,0x00,0x00,
		 0x00,0x00,0x3F,0x3F,0x00,0x00,0x00,0x00,
		 0x00,0x0C,0x1C,0x38,0x30,0x30,0x30,0x30,
		 0x39,0x1F,0x0F,0x00,0x00,0x00,0x00,0x3F,
		 0x3F,0x00,0x00,0x00,0x38,0x3F,0x07,0x06,
		 0x06,0x06,0x86,0x87,0xBF,0x38,0x00,0x00,
		 0xBF,0xBF,0xB0,0xB0,0xB0,0x30,0x30,0x30,
		 0xB0,0xB0,0x80,0x00,0x3F,0x3F,0x80,0x80,
		 0x00,0x00,0x00,0x80,0x80,0x00,0x03,0x0F,
		 0x9C,0xB8,0x30,0x30,0x38,0x1C,0x8F,0x83,
		 0x80,0x00,0x3F,0x3F,0x80,0x80,0x80,0x83,
		 0x07,0x1C,0x3F,0x3F,0x00,0x80,0x80,0x00,
		 0x3F,0x3F,0x00,0x00,0x00,0x80,0x30,0x3C,
		 0xBE,0xB3,0xB1,0xB0,0xB0,0xB0,0x30,0x30},
		 {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x80,0xC0,0xE0,0x70,0x38,0x1C,
		 0x0C,0x0C,0x1C,0x38,0x70,0x20,0x00,0x00,
		 0x80,0xC0,0xE0,0x70,0x38,0x1C,0x0C,0x0C,
		 0x1C,0x38,0x70,0xE0,0xC0,0x80,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x3E,0x7F,0xC1,0x80,0x80,0x41,0x00,0x00,
		 0xFF,0xFF,0x08,0x08,0x00,0x00,0xC0,0xF8,
		 0x3F,0x23,0x3F,0xF8,0xC0,0x00,0x80,0xE3,
		 0x77,0x1C,0x77,0xE3,0x80,0x00,0x02,0x01,
		 0xFF,0xFF,0x00,0x00,0x00,0x81,0xE1,0xF8,
		 0x9F,0x87,0x00,0x73,0xFF,0x8C,0x8C,0xFF,
		 0x73,0x00,0x7C,0xFE,0x87,0x85,0xFC,0x78,
		 0x00,0x30,0x28,0x26,0xFF,0xFF,0x20,0x00,
		 0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00},
		 {0x80,0x80,0x80,0x80,0x80,0x80,0x98,0x9C,
		 0x9E,0x9F,0x9F,0x9F,0x9F,0x80,0x80,0x80,
		 0x80,0x00,0x00,0x00,0xF8,0xFC,0xFE,0xFF,
		 0xFF,0xFF,0xFF,0x00,0x00,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x9F,0x9F,0x9F,0x9F,0x9E,
		 0x9C,0x98,0x80,0x80,0x80,0x80,0x80,0x80,
		 0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80,
		 0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,
		 0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,
		 0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80,
		 0x00,0x00,0x80,0x00,0x00,0x80,0x00,0x00,
		 0x80,0x00,0x00,0x80,0xC0,0xE0,0xF0,0x38,
		 0x1C,0x8E,0x06,0x06,0x8E,0x1C,0x38,0xF0,
		 0xE0,0x80,0x80,0x00,0x00,0x80,0x00,0x00,
		 0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,
		 0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80},
		 {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0xFF,0xFF,0x00,0x00,0x99,0x99,0x99,
		 0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,
		 0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,
		 0x00,0xC0,0xE0,0xB0,0xB8,0x9C,0x8E,0x86,
		 0x83,0x83,0x81,0x81,0x81,0x83,0x83,0x87,
		 0x8E,0x9C,0xB8,0xF0,0xE0,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
		 0xC0,0xF0,0xBC,0x9F,0x87,0x81,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
		 0x83,0x8F,0xBE,0xF8,0xE0,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80},
		 {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0xFF,0xFF,0x00,0x00,0x99,0x99,0x99,
		 0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,
		 0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,
		 0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0x01,0x03,0x0F,0x1D,
		 0x79,0xF1,0xC1,0x81,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x81,0xC1,0xE1,0x79,0x1D,0x0F,
		 0x03,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0x07,0x1F,0x7D,0xF1,
		 0xC1,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0xC1,0xF1,0x7F,0x1F},
		 {0x01,0x01,0x01,0x01,0x01,0x01,0x19,0x39,
		 0x79,0xF9,0xF9,0xF9,0xF9,0x01,0x01,0x01,
		 0x01,0x00,0x00,0x00,0x1F,0x3F,0x7F,0xFF,
		 0xFF,0xFF,0xFF,0x00,0x00,0x01,0x01,0x01,
		 0x01,0x01,0x01,0xF9,0xF9,0xF9,0xF9,0x79,
		 0x39,0x19,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x00,0x01,0x00,0x00,0x01,0x00,0x00,0x01,
		 0x00,0x00,0x01,0x00,0x00,0x01,0x00,0x00,
		 0x01,0x00,0x00,0x01,0x00,0x00,0x01,0x00,
		 0x00,0x01,0x01,0x01,0x03,0x07,0x06,0x07,
		 0x06,0x07,0x03,0x01,0x00,0x01,0x00,0x00,
		 0x01,0x00,0x00,0x01,0x00,0x00,0x01,0x00,
		 0x00,0x01,0x00,0x00,0x01,0x00,0x00,0x01,
		 0x00,0x00,0x01,0x00,0x00,0x01,0x00,0x03,
		 0x07,0x1E,0x38,0xF1,0xC0,0x80,0x81,0x80,
		 0xC0,0xF1,0x78,0x1F,0x07,0x01,0x00,0x01},
		 {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x01,0x03,0x07,0x0E,0x1C,0x38,
		 0x30,0x30,0x38,0x1C,0x0E,0x04,0x00,0x00,
		 0x01,0x03,0x07,0x0E,0x1C,0x38,0x30,0x30,
		 0x38,0x1C,0x0E,0x07,0x03,0x01,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x4C,0x92,0x92,0x92,0x64,0x00,0xFE,
		 0x04,0x08,0x04,0xFE,0x00,0xFC,0x22,0x22,
		 0x22,0xFC,0x00,0xFE,0x80,0x80,0x80,0x80,
		 0x00,0xFE,0x80,0x80,0x80,0x80,0x00,0x00,
		 0x00,0x00,0x00,0x78,0x94,0x92,0x92,0x60,
		 0x00,0xD8,0x20,0x20,0xD8,0x00,0x00,0x6C,
		 0x92,0x92,0x92,0x6C,0x00,0x00,0x00,0x00,
		 0x00,0x02,0x02,0xFE,0x02,0x02,0x00,0xFE,
		 0x92,0x92,0x92,0x82,0x01,0xC7,0x29,0x11,
		 0x29,0xC6,0x00,0x02,0x02,0xFE,0x02,0x02}};
/////////////////////////////////////////////////////////////////////////////
const unsigned char CFAX12864U[8][128]=
   {{0xF0,0xFC,0x0E,0x07,0x03,0x03,0x03,0x07,
		 0x0E,0x0C,0x00,0xFF,0xFF,0x83,0x83,0x83,
		 0x83,0x83,0xC7,0xFE,0x7C,0x00,0x03,0x0F,
		 0x3C,0xF0,0xC0,0xC0,0xF0,0x3C,0x0F,0x03,
		 0x00,0x3C,0x7E,0xE7,0xC3,0xC3,0xC3,0xC3,
		 0xC7,0x8E,0x0C,0x00,0x03,0x03,0x03,0xFF,
		 0xFF,0x03,0x03,0x03,0x00,0x00,0xE0,0xFC,
		 0x1F,0x1F,0xFC,0xE0,0x00,0x00,0x00,0x00,
		 0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x00,0x00,0xFF,0xFF,0xC3,0xC3,
		 0xC3,0xC3,0xC3,0xC3,0x03,0x03,0xF0,0xFC,
		 0x0E,0x07,0x03,0x03,0x07,0x0E,0xFC,0xF0,
		 0x00,0x00,0xFF,0xFF,0x0E,0x38,0xF0,0xC0,
		 0x00,0x00,0xFF,0xFF,0x00,0x03,0x03,0x03,
		 0xFF,0xFF,0x03,0x03,0x03,0x00,0x03,0x03,
		 0x03,0x03,0xC3,0xE3,0x33,0x1F,0x0F,0x03},
		 {0x03,0x0F,0x1C,0x38,0x30,0x30,0x30,0x38,
		 0x1C,0x0C,0x00,0x3F,0x3F,0x01,0x01,0x03,
		 0x07,0x0F,0x1D,0x38,0x30,0x00,0x00,0x00,
		 0x00,0x00,0x3F,0x3F,0x00,0x00,0x00,0x00,
		 0x00,0x0C,0x1C,0x38,0x30,0x30,0x30,0x30,
		 0x39,0x1F,0x0F,0x00,0x00,0x00,0x00,0x3F,
		 0x3F,0x00,0x00,0x00,0x38,0x3F,0x07,0x06,
		 0x06,0x06,0x06,0x87,0xBF,0xB8,0x00,0x00,
		 0x3F,0xBF,0xB0,0xB0,0xB0,0xB0,0x30,0x30,
		 0xB0,0xB0,0x80,0x00,0x3F,0x3F,0x80,0x80,
		 0x00,0x00,0x00,0x80,0x80,0x00,0x03,0x0F,
		 0x9C,0xB8,0x30,0x30,0x38,0x1C,0x8F,0x83,
		 0x80,0x00,0x3F,0x3F,0x80,0x80,0x80,0x83,
		 0x07,0x1C,0x3F,0x3F,0x00,0x80,0x80,0x00,
		 0x3F,0x3F,0x00,0x00,0x00,0x80,0x30,0x3C,
		 0xBE,0xB3,0x31,0x30,0x30,0xB0,0xB0,0x30},
		 {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x80,0xC0,0xE0,0x70,0x38,0x1C,
		 0x0C,0x0C,0x1C,0x38,0x70,0x20,0x00,0x00,
		 0x80,0xC0,0xE0,0x70,0x38,0x1C,0x0C,0x0C,
		 0x1C,0x38,0x70,0xE0,0xC0,0x80,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x3E,0x7F,0xC1,0x80,0x80,0x41,0x00,
		 0x00,0xFF,0xFF,0x08,0x08,0x00,0xC0,0xF8,
		 0x3F,0x23,0x3F,0xF8,0xC0,0x00,0x80,0xE3,
		 0x77,0x1C,0x77,0xE3,0x80,0x00,0x02,0x01,
		 0xFF,0xFF,0x00,0x00,0x00,0x81,0xE1,0xF8,
		 0x9F,0x87,0x00,0x73,0xFF,0x8C,0x8C,0xFF,
		 0x73,0x00,0x7C,0xFE,0x87,0x85,0xFC,0x78,
		 0x00,0x30,0x28,0x26,0xFF,0xFF,0x20,0x00,
		 0x7F,0xFF,0x80,0x80,0x80,0xFF,0x7F,0x00},
		 {0x80,0x80,0x80,0x80,0x80,0x80,0x98,0x9C,
		 0x9E,0x9F,0x9F,0x9F,0x9F,0x80,0x80,0x80,
		 0x80,0x00,0x00,0x00,0xF8,0xFC,0xFE,0xFF,
		 0xFF,0xFF,0xFF,0x00,0x00,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x9F,0x9F,0x9F,0x9F,0x9E,
		 0x9C,0x98,0x80,0x80,0x80,0x80,0x80,0x80,
		 0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80,
		 0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,
		 0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,
		 0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80,
		 0x00,0x00,0x80,0x00,0x00,0x80,0x00,0x00,
		 0x80,0x00,0x00,0x80,0xC0,0xE0,0xF0,0x38,
		 0x1C,0x8E,0x06,0x06,0x8E,0x1C,0x38,0xF0,
		 0xE0,0x80,0x80,0x00,0x00,0x80,0x00,0x00,
		 0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,
		 0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80},
		 {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0xFF,0xFF,0x00,0x00,0x99,0x99,0x99,
		 0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,
		 0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,
		 0x00,0xC0,0xE0,0xB0,0xB8,0x9C,0x8E,0x86,
		 0x83,0x83,0x81,0x81,0x81,0x83,0x83,0x87,
		 0x8E,0x9C,0xB8,0xF0,0xE0,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
		 0xC0,0xF0,0xBC,0x9F,0x87,0x81,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
		 0x83,0x8F,0xBE,0xF8,0xE0,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
		 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80},
		 {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,
		 0xFF,0xFF,0xFF,0x00,0x00,0x99,0x99,0x99,
		 0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,
		 0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,
		 0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0x01,0x03,0x0F,0x1D,
		 0x79,0xF1,0xC1,0x81,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x81,0xC1,0xE1,0x79,0x1D,0x0F,
		 0x03,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0x07,0x1F,0x7D,0xF1,
		 0xC1,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x01,0x01,0x01,0x01,0xC1,0xF1,0x7F,0x1F},
		 {0x01,0x01,0x01,0x01,0x01,0x01,0x19,0x39,
		 0x79,0xF9,0xF9,0xF9,0xF9,0x01,0x01,0x01,
		 0x01,0x00,0x00,0x00,0x1F,0x3F,0x7F,0xFF,
		 0xFF,0xFF,0xFF,0x00,0x00,0x01,0x01,0x01,
		 0x01,0x01,0x01,0xF9,0xF9,0xF9,0xF9,0x79,
		 0x39,0x19,0x01,0x01,0x01,0x01,0x01,0x01,
		 0x00,0x01,0x00,0x00,0x01,0x00,0x00,0x01,
		 0x00,0x00,0x01,0x00,0x00,0x01,0x00,0x00,
		 0x01,0x00,0x00,0x01,0x00,0x00,0x01,0x00,
		 0x00,0x01,0x01,0x01,0x03,0x07,0x06,0x07,
		 0x06,0x07,0x03,0x01,0x00,0x01,0x00,0x00,
		 0x01,0x00,0x00,0x01,0x00,0x00,0x01,0x00,
		 0x00,0x01,0x00,0x00,0x01,0x00,0x00,0x01,
		 0x00,0x00,0x01,0x00,0x00,0x01,0x00,0x03,
		 0x07,0x1E,0x38,0xF1,0xC0,0x80,0x81,0x80,
		 0xC0,0xF1,0x78,0x1F,0x07,0x01,0x00,0x01},
		 {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x01,0x03,0x07,0x0E,0x1C,0x38,
		 0x30,0x30,0x38,0x1C,0x0E,0x04,0x00,0x00,
		 0x01,0x03,0x07,0x0E,0x1C,0x38,0x30,0x30,
		 0x38,0x1C,0x0E,0x07,0x03,0x01,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x4C,0x92,0x92,0x92,0x64,0x00,0xFE,
		 0x04,0x08,0x04,0xFE,0x00,0xFC,0x22,0x22,
		 0x22,0xFC,0x00,0xFE,0x80,0x80,0x80,0x80,
		 0x00,0xFE,0x80,0x80,0x80,0x80,0x00,0x00,
		 0x00,0x00,0x00,0x78,0x94,0x92,0x92,0x60,
		 0x00,0xD8,0x20,0x20,0xD8,0x00,0x00,0x6C,
		 0x92,0x92,0x92,0x6C,0x00,0x00,0x00,0x00,
		 0x00,0x02,0x02,0xFE,0x02,0x02,0x00,0xFE,
		 0x92,0x92,0x92,0x82,0x01,0xC7,0x29,0x11,
		 0x29,0xC6,0x00,0x02,0x02,0xFE,0x02,0x02}};

const unsigned char tractor[8][128]=
   {{0x00,0x00,0x08,0x40,0x00,0x80,0x00,0x08,
		 0x00,0x00,0x08,0x00,0x20,0x00,0x80,0x20,
		 0xA4,0x48,0xAC,0x08,0xAC,0x90,0x08,0x90,
		 0x08,0x50,0x48,0xB0,0x28,0xC0,0x58,0x60,
		 0xA8,0xC0,0x38,0xC0,0x58,0x50,0xA0,0x58,
		 0xD0,0x90,0x50,0x50,0x50,0xB0,0x40,0x50,
		 0xD0,0x10,0xE0,0x10,0xE0,0x10,0x60,0x40,
		 0xB0,0x40,0xA0,0xA0,0x40,0xA0,0x40,0xA8,
		 0xAA,0x42,0xE0,0xA2,0xC0,0x24,0xDC,0x68,
		 0x48,0xD8,0xB0,0xA8,0x54,0xE8,0xB8,0x20,
		 0xE8,0x58,0x70,0xE0,0x20,0xE0,0x40,0x40,
		 0x50,0x40,0xD0,0xE0,0x50,0xF8,0xB0,0x6C,
		 0xFC,0x54,0xFC,0x9C,0x74,0x5C,0xAC,0x54,
		 0xEC,0x54,0xFC,0xA0,0x50,0xF4,0xA0,0xD8,
		 0xE0,0xA0,0x40,0xC4,0x48,0xC0,0x80,0x00,
		 0x14,0x00,0x00,0x08,0x10,0x80,0x00,0x00},
		{0x00,0x00,0x20,0x00,0x10,0x00,0x80,0x01,
		 0x00,0x00,0x04,0x40,0x00,0x00,0x01,0xEA,
		 0xBD,0xD2,0x2D,0x66,0x4A,0xDD,0x22,0x54,
		 0x25,0xDE,0x22,0x5D,0xF3,0x26,0xCD,0x12,
		 0xC2,0x3F,0xC9,0x21,0xC1,0x32,0xE5,0xDE,
		 0xA2,0xDD,0x93,0x7D,0xC2,0xBD,0xC3,0x3C,
		 0xCB,0x32,0x4D,0x5A,0x55,0x6B,0x15,0xFA,
		 0x83,0x7C,0x45,0x6A,0xCB,0xBA,0xA5,0x5A,
		 0xD5,0xDE,0xB2,0xED,0x13,0xEE,0xBB,0x55,
		 0xEF,0x5A,0xED,0xBB,0xD6,0xBD,0x93,0x2D,
		 0x42,0x1D,0x11,0xD1,0x95,0xF1,0xDA,0x75,
		 0xEF,0xBB,0xDE,0xB7,0xAB,0x4D,0x5B,0x64,
		 0x5F,0xFA,0x52,0xED,0xBB,0xEF,0xBA,0x75,
		 0x6F,0xBD,0xCA,0x1F,0x3B,0x46,0xBD,0x06,
		 0xBF,0x95,0x2F,0xDD,0x3B,0x6E,0xEB,0x5F,
		 0xFC,0xB9,0x74,0xE0,0x80,0x00,0x22,0x00},
		{0x00,0x00,0x04,0x00,0x20,0x00,0x00,0x12,
		 0x80,0x00,0x00,0x01,0x40,0x00,0x00,0x9A,
		 0xB5,0x6F,0x90,0x6F,0x90,0xB5,0x03,0xDA,
		 0x82,0x39,0xC3,0x3C,0xD3,0x2E,0x51,0x82,
		 0x2D,0x9A,0x21,0x84,0x1B,0x72,0xAF,0x6A,
		 0x3A,0xE5,0xDF,0x2A,0x0A,0xAB,0x7A,0xDB,
		 0xE2,0xBF,0xD5,0x6E,0xD3,0xAD,0xE2,0xBE,
		 0x63,0xDE,0x75,0xAB,0xFA,0xC3,0x9E,0x71,
		 0xA6,0xFD,0x95,0x7F,0xC2,0x7D,0xE6,0x5F,
		 0xFA,0xB7,0xED,0xAA,0x6F,0xBA,0xCB,0xBD,
		 0xEB,0x5E,0xEB,0xDE,0x6B,0xDE,0x75,0xCF,
		 0x7A,0x5A,0x35,0x54,0x98,0x73,0xCE,0xBD,
		 0xF5,0x2F,0xFB,0x8E,0x53,0xCE,0xBA,0x67,
		 0x5A,0xFD,0xBB,0x65,0xDF,0xBE,0x75,0xAF,
		 0x7A,0x56,0x6B,0x7C,0xF3,0x24,0x61,0x87,
		 0xAA,0x1F,0xFB,0xB6,0x57,0xFE,0xC0,0x00},
		{0x00,0x00,0x00,0x04,0x00,0x08,0x80,0x00,
		 0x80,0x88,0x90,0x40,0xC0,0x40,0xC0,0xCE,
		 0x39,0x56,0xE5,0xAA,0x55,0xB5,0x64,0xCC,
		 0xB1,0xA4,0xD5,0xA2,0xE5,0xDE,0x30,0x66,
		 0xCC,0x38,0xF3,0x05,0xD1,0x4B,0x20,0xC5,
		 0xBB,0x02,0xF5,0x9D,0x24,0x43,0xA6,0x9F,
		 0x20,0x47,0xDD,0x27,0xEC,0x0A,0x59,0x94,
		 0x0D,0xFD,0xCA,0x2A,0xDB,0xFC,0x9B,0xF6,
		 0x0A,0xED,0xA3,0xA6,0x5D,0xDB,0xB5,0x2E,
		 0xDB,0x96,0x75,0xEF,0x5D,0xFA,0xDF,0xF2,
		 0xAF,0x7D,0xD6,0x6F,0x9A,0x77,0xDC,0x73,
		 0xAD,0x4A,0xBD,0x26,0xDD,0xD3,0x7D,0xD7,
		 0xFD,0x03,0xEE,0xB9,0xEF,0xBA,0x5F,0xF3,
		 0xAF,0xA2,0x55,0xEA,0x95,0xAD,0x53,0xAD,
		 0x5B,0xA3,0x5F,0xF0,0x47,0x8B,0xA5,0x0C,
		 0x21,0x00,0xFF,0xAB,0xFE,0x2D,0x79,0x00},
		{0x00,0x44,0xA0,0xB9,0x64,0xDA,0xA2,0x7F,
		 0xDA,0xF7,0xBD,0x57,0xFD,0xB7,0xEE,0x17,
		 0xE4,0x5B,0xFE,0xD5,0xAF,0x7D,0xDB,0xEE,
		 0xBB,0xEE,0x0D,0x0A,0x17,0x8D,0x4B,0x4C,
		 0xE7,0xAC,0x55,0x7E,0xD0,0xB2,0xB4,0x4D,
		 0xFB,0x56,0xDA,0xF2,0x95,0x70,0xAE,0xD1,
		 0x95,0x8A,0x02,0x0E,0x01,0x07,0x0C,0x4F,
		 0x3A,0xD5,0x37,0xEA,0xB7,0x6C,0xDB,0xFD,
		 0xAA,0x7D,0xEA,0xAF,0x55,0xC6,0xAF,0x92,
		 0x0F,0x4A,0x6D,0xA6,0x9F,0xAA,0x8E,0x52,
		 0xE3,0xA7,0xFD,0x69,0xE3,0xCE,0x3D,0xED,
		 0xBA,0x6F,0xDD,0x3B,0xE6,0xDD,0x77,0xDD,
		 0xF7,0xBA,0xD6,0x25,0xDA,0xCF,0xBB,0x5E,
		 0xF5,0xDF,0xBA,0x37,0xEA,0x9F,0x74,0x5A,
		 0xC0,0xBE,0x65,0x5D,0xAF,0x08,0x10,0xC2,
		 0xA0,0xFE,0xBD,0xE7,0x1D,0x8F,0x08,0x00},
		{0x00,0x37,0x6E,0xFB,0xB7,0xEE,0x5B,0xFF,
		 0x6A,0xFF,0xAD,0xFB,0xAE,0x7D,0x98,0x77,
		 0xDD,0x36,0xEF,0x3A,0xF7,0xAD,0xFE,0xB5,
		 0x6F,0xDD,0xB9,0x4C,0xF3,0xBC,0xC7,0xBB,
		 0xEC,0x3B,0xFD,0x12,0xFF,0xA5,0x2B,0xDD,
		 0xBB,0x23,0x5E,0xE9,0xAF,0xBB,0x26,0x5D,
		 0xEE,0x6B,0xDE,0x78,0xC4,0x00,0x08,0x90,
		 0x00,0x01,0x08,0x43,0x45,0x47,0x2E,0xDB,
		 0x3F,0xD5,0x3F,0x75,0xAF,0x7F,0xBA,0xD7,
		 0xBF,0x5B,0x6F,0xFA,0xAF,0xBB,0x7F,0xA5,
		 0xFE,0x1F,0xF5,0x5D,0xF3,0xAC,0xDB,0x7A,
		 0xD7,0xDD,0xBB,0xD7,0xBE,0xEB,0xFB,0xB6,
		 0xED,0x5F,0xFD,0xAE,0x7A,0xED,0xDB,0xBA,
		 0xE3,0xE5,0x23,0xE1,0xCA,0x51,0xE5,0xB5,
		 0xE0,0xD2,0xB4,0x68,0xDC,0x7B,0xEE,0xBB,
		 0x6E,0xDB,0x31,0xE3,0x14,0xE8,0xA2,0x68},
		{0x40,0x81,0x08,0x23,0x02,0x4F,0x0D,0x5B,
		 0x16,0x2F,0x5A,0x1F,0x55,0x0F,0x9A,0x1F,
		 0x15,0x4E,0x2F,0x0B,0x96,0x0F,0x2A,0x85,
		 0x3D,0x2E,0xFB,0x4F,0xFC,0x6B,0xFE,0xD5,
		 0x5F,0xF5,0xAE,0x5A,0xEE,0x39,0xE2,0x9C,
		 0x7D,0x93,0x6D,0x5A,0x35,0x66,0xAD,0xA0,
		 0x5F,0xF9,0xB7,0x4D,0x15,0x2E,0x08,0xB2,
		 0x05,0xA4,0x29,0x46,0x09,0x5A,0x01,0x94,
		 0x83,0x04,0x13,0x84,0x03,0x02,0x8A,0x02,
		 0x01,0x27,0x01,0x06,0x22,0x05,0x23,0x02,
		 0x81,0x05,0x00,0x45,0x00,0x84,0x09,0x12,
		 0x41,0x02,0x21,0x04,0x0B,0x42,0x9B,0x05,
		 0x3F,0x2D,0x1B,0x3F,0x1D,0xBB,0x16,0xBD,
		 0x17,0x1F,0xBB,0x2E,0x1B,0x37,0x4E,0x1B,
		 0x1D,0x47,0x8D,0x17,0x05,0x4F,0x0C,0xA3,
		 0x05,0x05,0x97,0x02,0x03,0x22,0x05,0x01},
		{0x00,0x42,0x08,0x42,0x90,0x02,0x20,0x81,
		 0x14,0x00,0x82,0x08,0x12,0x80,0x02,0x88,
		 0x10,0x02,0x11,0x00,0x20,0x02,0x40,0x00,
		 0x05,0x08,0x13,0x07,0x2A,0x1F,0x31,0x2F,
		 0x7B,0x2E,0x5B,0x7E,0x3D,0x63,0x5C,0x75,
		 0x2E,0xB9,0x16,0x3D,0x15,0x1F,0x12,0x0F,
		 0x23,0x04,0x1A,0x04,0x01,0x0A,0x02,0x04,
		 0x0A,0x81,0x02,0x09,0x01,0x41,0x00,0x02,
		 0x00,0x01,0x04,0x08,0x00,0x88,0x00,0x00,
		 0x04,0x10,0x82,0x00,0x00,0x80,0x09,0x00,
		 0x90,0x00,0x02,0x08,0x90,0x00,0x00,0x12,
		 0x00,0x11,0x00,0x02,0x40,0x08,0x40,0x81,
		 0x08,0x21,0x00,0x01,0x20,0x04,0x40,0x02,
		 0x40,0x04,0x08,0x21,0x00,0x14,0x00,0x82,
		 0x08,0x00,0x20,0x02,0x08,0x00,0x22,0x00,
		 0x80,0x04,0x08,0x01,0x20,0x41,0x04,0x00}};
/////////////////////////////////////////////////////////////////////////////

BOOL CCFAX_WINTESTDlg::OnInitDialog()
{
  char
    string[10];
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_Contrast_Slider.SetRange(0, 63);
	m_Range_Slider.SetRange(0, 7);

  //0=CFAX12864T 1=CFAX12864U	
	m_device.SetCurSel(0);
  display_type=m_device.GetCurSel();

  if(display_type)
    {
    //CFAX12864U
    last_contrast=CFAX12864U_CONTRAST;
    last_range=CFAX12864U_RANGE;
    }
  else
    {
    //CFAX12864T
    last_contrast=CFAX12864T_CONTRAST;
    last_range=CFAX12864T_RANGE;
    }
	m_Contrast_Slider.SetPos(last_contrast);
  sprintf(string,"%d",last_contrast);
	m_Contrast_Setting.SetWindowText(string);
	m_Range_Slider.SetPos(last_range);
  sprintf(string,"%d",last_range);
	m_Range_Setting.SetWindowText(string);


  //0 => 0x378, 1 => 0x278. 2 => 0x3BC
  m_address.SetCurSel(0);
  switch(m_address.GetCurSel())
    {
    case 1:
      port_data_address=0x278;
      break;
    case 2:
      port_data_address=0x3BC;
      break;
    default:
      port_data_address=0x378;
      break;
    }
  port_control_address=port_data_address+2;



	m_Shift_Slider.SetRange(0, 63);
	m_Shift_Slider.SetPos(last_shift=0);
  sprintf(string,"%d",last_shift);
	m_Shift_Setting.SetWindowText(string);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCFAX_WINTESTDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCFAX_WINTESTDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCFAX_WINTESTDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//========================================================================
typedef unsigned char ubyte;



ubyte
  control;  //value of "*port_control_address"

#define DATA_ADDR (port_data_address)
#define CONT_ADDR (port_control_address)

//inverted at the port
#define CLR_RD (DlPortWritePortUchar(CONT_ADDR,(control|=0x01)))
#define SET_RD (DlPortWritePortUchar(CONT_ADDR,(control&=~0x01)))
  
//inverted at the port
#define CLR_WR (DlPortWritePortUchar(CONT_ADDR,(control|=0x02)));(Sleep(1))
#define FCLR_WR (DlPortWritePortUchar(CONT_ADDR,(control|=0x02)))
#define SET_WR (DlPortWritePortUchar(CONT_ADDR,(control&=~0x02)))
  
//straight at the port
#define SET_RS (DlPortWritePortUchar(CONT_ADDR,(control|=0x04)))
#define CLR_RS (DlPortWritePortUchar(CONT_ADDR,(control&=~0x04)))

//inverted at the port
#define CLR_RES (DlPortWritePortUchar(CONT_ADDR,(control|=0x08)))
#define SET_RES (DlPortWritePortUchar(CONT_ADDR,(control&=~0x08)))

#define DATA(x) (DlPortWritePortUchar(DATA_ADDR,(x)));(Sleep(1))
#define FDATA(x) (DlPortWritePortUchar(DATA_ADDR,(x)))

void CCFAX_WINTESTDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
	int
    new_contrast;
	int
    new_range;
	int
    new_shift;
  char
    string[10];
	if(last_contrast!=(new_contrast=m_Contrast_Slider.GetPos()))
		{
    //Contrast
    DATA(0x81);
    CLR_WR;
    SET_WR;
    Sleep(1);
    DATA(new_contrast&0x3F);
    CLR_WR;
    SET_WR;
    Sleep(1);

    sprintf(string,"%d",new_contrast);
		m_Contrast_Setting.SetWindowText(string);
    last_contrast=new_contrast;
		}

	if(last_range!=(new_range=m_Range_Slider.GetPos()))
		{
    //Range
    DATA(0x20|(new_range&0x07));
    CLR_WR;
    SET_WR;
    Sleep(1);

    sprintf(string,"%d",new_range);
		m_Range_Setting.SetWindowText(string);
    last_range=new_range;
		}

	if(last_shift!=(new_shift=m_Shift_Slider.GetPos()))
		{
    //Initial Display Line
    DATA(0x40|(new_shift&0x03F));
    CLR_WR;
    SET_WR;
    Sleep(1);

    sprintf(string,"%d",new_shift);
		m_Shift_Setting.SetWindowText(string);
    last_shift=new_shift;
		}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
  }


void CCFAX_WINTESTDlg::OnInitialize() 
  {
	CWaitCursor wait;
  char
    string[10];

  //0=CFAX12864T 1=CFAX12864U	
  display_type=m_device.GetCurSel();

  if(display_type)
    {
    //CFAX12864U
    last_contrast=CFAX12864U_CONTRAST;
    last_range=CFAX12864U_RANGE;
    }
  else
    {
    //CFAX12864T
    last_contrast=CFAX12864T_CONTRAST;
    last_range=CFAX12864T_RANGE;
    }
	m_Contrast_Slider.SetPos(last_contrast);
  sprintf(string,"%d",last_contrast);
	m_Contrast_Setting.SetWindowText(string);
	m_Range_Slider.SetPos(last_range);
  sprintf(string,"%d",last_range);
	m_Range_Setting.SetWindowText(string);

  //0 => 0x378, 1 => 0x278. 2 => 0x3BC
  switch(m_address.GetCurSel())
    {
    case 1:
      port_data_address=0x278;
      break;
    case 2:
      port_data_address=0x3BC;
      break;
    default:
      port_data_address=0x378;
      break;
    }
  port_control_address=port_data_address+2;

  ubyte
    i;
  i=0;

  //Idle RW and WR
  SET_RD;
  SET_WR;

  //Talk to the control register.
  CLR_RS;

  //Strobe the reset. It is already low.
  //Stay in reset while the power settles down
  CLR_RES;
  Sleep(100);
  SET_RES;
  Sleep(100);

  //Software reset command
  DATA(0xE2);
  CLR_WR;
  SET_WR;
  Sleep(100);

  //Display on
  DATA(0xAF);
  CLR_WR;
  SET_WR;
  Sleep(100);

  //Display normal EON
  DATA(0xA4);
  CLR_WR;
  SET_WR;
  Sleep(10);

  //Display normal REV
  DATA(0xA6);
  CLR_WR;
  SET_WR;
  Sleep(10);


  //LCD Bias (A2 A3)
  DATA(0xA3);
  CLR_WR;
  SET_WR;
  Sleep(10);


  //ADC (A0, A1) (Flips display left to right, assuming landscape orientation)
  DATA(0xA1);
  CLR_WR;
  SET_WR;
  Sleep(10);

  //SHL (C8 C0) (Flips display top to bottom, assuming landscape orientation)
  DATA(0xC8);
  CLR_WR;
  SET_WR;
  Sleep(10);

  //VC
  DATA(0x2C);
  CLR_WR;
  SET_WR;
  Sleep(10);

  //VR
  DATA(0x2E);
  CLR_WR;
  SET_WR;
  Sleep(10);

  //VF
  DATA(0x2F);
  CLR_WR;
  SET_WR;
  Sleep(10);

  //Resistor (20 - 27)
  //This acts like a "range" contol on the contrast. 7 = dark 6 = OK, all others too light.
  DATA(0x20|(last_range&0x07));
  CLR_WR;
  SET_WR;
  Sleep(10);

  //Contrast (81 + 0 - 3F)
  DATA(0x81);
  CLR_WR;
  SET_WR;
  Sleep(10);

  DATA(last_contrast&0x3F);
//  DATA(0x1F);
  CLR_WR;
  SET_WR;
  Sleep(10);


  //Stabilize
  Sleep(100);


  //Static Indicator (not working)
  DATA(0xAD);
  CLR_WR;
  SET_WR;
  Sleep(1);

  DATA(0x02);  //1/2 sec blink
  CLR_WR;
  SET_WR;
  Sleep(1);

  //Initial Display Line
  DATA(0x40);
  CLR_WR;
  SET_WR;
  Sleep(1);

  //Page Address
  DATA(0xB0);
  CLR_WR;
  SET_WR;
  Sleep(1);

  //High Column
  DATA(0x10);
  CLR_WR;
  SET_WR;
  Sleep(1);

  //Low Column
  DATA(0x00);
  CLR_WR;
  SET_WR;
  Sleep(1);

  ubyte
    data;
  data=0xFF;
  int
    row;
  for(row=0;row<=7;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(display_type?CFAX12864U[row][col]:CFAX12864T[row][col]);
		  FCLR_WR;
		  SET_WR;
      data^=0xFF;
      }
    CLR_RS;
    }
	
}


void CCFAX_WINTESTDlg::OnClear() 
  {
  int
    row;
  for(row=0;row<=8;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(0);
      FCLR_WR;
		  SET_WR;
      }
    CLR_RS;
    }
  }

void CCFAX_WINTESTDlg::OnCheckerboard() 
  {
  ubyte
    data;
  data=0xAA;
  int
    row;
  for(row=0;row<=7;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(data);
		  FCLR_WR;
		  SET_WR;
      data^=0xFF;
      }
    CLR_RS;
    }
	
}

void CCFAX_WINTESTDlg::OnHStripes() 
{
  int
    row;
  for(row=0;row<=7;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(0xAA);
		  FCLR_WR;
		  SET_WR;
      }
    CLR_RS;
    }	
}

void CCFAX_WINTESTDlg::OnVStripes() 
{
  ubyte
    data;
  data=0xFF;
  int
    row;
  for(row=0;row<=7;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(data);
		  FCLR_WR;
		  SET_WR;
      data^=0xFF;
      }
    CLR_RS;
    }
	
}

void CCFAX_WINTESTDlg::OnSet() 
{
  int
    row;
  for(row=0;row<=8;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(0xFF);
      FCLR_WR;
		  SET_WR;
      }
    CLR_RS;
    }	
}

void CCFAX_WINTESTDlg::OnDiagonals() 
{
  int
    row;
  for(row=0;row<=7;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(0x333>>(col&0x03));
		  FCLR_WR;
		  SET_WR;
      }
    CLR_RS;
    }
	
}

void CCFAX_WINTESTDlg::OnTractor() 
{
  int
    row;
  for(row=0;row<=7;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(tractor[row][col]);
		  FCLR_WR;
		  SET_WR;
      }
    CLR_RS;
    }
	
	
}

void CCFAX_WINTESTDlg::OnLogo() 
{
  int
    row;
  for(row=0;row<=7;row++)
    {
    //Page Address
    DATA(0xB0|row);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //High Column
    DATA(0x10);
    CLR_WR;
    SET_WR;
    Sleep(1);

    //Low Column For some reason the Left-most column of the
    //CFAX12864 is at 4. Hmmm.
    DATA(0x04);
    CLR_WR;
    SET_WR;
    Sleep(1);


    SET_RS;
    int
      col;
    for(col=0;col<=127;col++)
      {
      FDATA(display_type?CFAX12864U[row][col]:CFAX12864T[row][col]);
		  FCLR_WR;
		  SET_WR;
      }
    CLR_RS;
    }	
}

void CCFAX_WINTESTDlg::OnEditchangeDevice() 
  {

  }

void CCFAX_WINTESTDlg::OnEditchangeAddress() 
  {

  }
